using System;
using System.Diagnostics;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;

using TAPI;
using Terraria;

namespace Terra.NPCs {
    
    public class SkeletalSeller : ModNPC {

		public override bool? CanHitFriendNPC(NPC npc) { return false; }

		public override bool CanTownNPCSpawn() 
		{
			if(NPC.downedBoss2 == true) 
			{
			return true;
			} 
			return false;
		}        
		public override void HitEffect(int hitDirection, double damage, bool isDead) {
            
			if (Main.netMode != 2) {
                
				for (int m = 0; m < (isDead ? 20 : 5); m++) {
                    
					int dustID = Dust.NewDust(npc.position, npc.width, npc.height, 5, npc.velocity.X * 0.2f, npc.velocity.Y * 0.2f, 100, Color.White, isDead && m % 2 == 0 ? 3f : 1f);
					
                    if (isDead && m % 2 == 0) {
                        Main.dust[dustID].noGravity = true;
                    }
                    
				}
                
				if (isDead) {
                    
                    // This code will crash your game unless you have the necessary textures in your Gores folder
                    // Remove the next 4 lines if you don't include the textures
                    
				}
                
			}
            
		}

        public override string SetName() {
            
            int rand = Main.rand.Next(5);
            string name = "";
            
            switch(rand) {
                
                case 0:
                    name = "Sukor";
                    break;
                    
                case 1:
                    name = "Uskor";
                    break;
                    
                case 2:
                    name = "Tyguis";
                    break;

                case 3:
                    name = "Osiris";
                    break;
                    
                default:
                    name = "Skeleton King";
                    break;
                    
            }
            
            return name;
            
        }

        public override string SetChat() {
            
            int rand = Main.rand.Next(6);
            string text = "";
            
            switch (rand) {
                
                case 0:
                    text = "My brother would never approve of this. Well, maybe he would. Who knows?";
                    break;
                
                case 1:
                    text = "I herd U liek Bonekips? No? Am I not up to date? Am I not hip?";
                    break;
                
                case 2:
                    text = "Don't. Try. That. Ever. Again. Got it?";
                    break;

                case 3:
                    text = "I may not look like it, but I'm a very nice person. Sometimes.";
                    break;

                case 4:
                    text = "So I heard that Friendship was Magic. Is Friendship magic?";
                    break;
                
                default:
                    text = "So... what exactly happened?";
                    break;
                
            }
            
            return text;
            
        }

        public override void SetupShop(Chest chest, ref int index) {
            
            // The cost to buy this item is the value that was in the items JSON file
            chest.item[index].SetDefaults(ItemDef.byName["Vanilla:Bone"].type);
            index++;
            
            chest.item[index].SetDefaults(ItemDef.byName["Vanilla:Silk"].type);
            index++;
            
            chest.item[index].SetDefaults(ItemDef.byName["Terra:Bandaid"].type);
            chest.item[index].value = (int)(chest.item[index].value * 3); // The cost to buy this item is 50% more than original
            index++;
            
            chest.item[index].SetDefaults(ItemDef.byName["Vanilla:Tombstone"].type);
            index++;
            
        }
        
        public override bool ResetShop(Chest chest) { return true; }

        public override void SetChatButtons(ref string[] buttons) {//you can have up to 5 buttons (0-4)
			buttons[0] = "Shop";
		}
        
		public override void OnChatButtonClicked(string[] buttons, int buttonIndex, ref bool openShop) {
            
			if (buttonIndex == 0) {
				openShop = true;
			}
            
		}
        
    }
    
}