using System;
using System.Diagnostics;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;

using TAPI;
using Terraria;

namespace Terra.NPCs {
    
    public class TopHatSkeleton : ModNPC {

		public override bool? CanHitFriendNPC(NPC npc) { return false; }

		public override bool CanTownNPCSpawn() 
		{
			if(NPC.downedBoss1 == true) 
			{
			return true;
			} 
			return false;
		}        
		public override void HitEffect(int hitDirection, double damage, bool isDead) {
            
			if (Main.netMode != 2) {
                
				for (int m = 0; m < (isDead ? 20 : 5); m++) {
                    
					int dustID = Dust.NewDust(npc.position, npc.width, npc.height, 5, npc.velocity.X * 0.2f, npc.velocity.Y * 0.2f, 100, Color.White, isDead && m % 2 == 0 ? 3f : 1f);
					
                    if (isDead && m % 2 == 0) {
                        Main.dust[dustID].noGravity = true;
                    }
                    
				}
                
				if (isDead) {
                    
                    // This code will crash your game unless you have the necessary textures in your Gores folder
                    // Remove the next 4 lines if you don't include the textures
                    
				}
                
			}
            
		}

        public override string SetName() {
            
            int rand = Main.rand.Next(4);
            string name = "";
            
            switch(rand) {
                
                case 0:
                    name = "The Great Vesk";
                    break;
                    
                case 1:
                    name = "The Powerful Vesk";
                    break;

                case 2:
                    name = "The Great and Powerful Vesk";
                    break;
                    
                default:
                    name = "Vesk";
                    break;
                    
            }
            
            return name;
            
        }

        public override string SetChat() {
            
            int rand = Main.rand.Next(6);
            string text = "";
            
            switch (rand) {
                
                case 0:
                    text = "Hehehe... I know a lot more than I may seem I do.";
                    break;
                
                case 1:
                    text = "I once worked with the Skeleton King. Good times.";
                    break;
                
                case 2:
                    text = "Have you happened to have seen Thorns anywhere?";
                    break;

                case 3:
                    text = "You've... found Skeletron? No? Ah... We'll find him...";
                    break;

                case 4:
                    text = "I've got a party cannon.";
                    break;
                
                default:
                    text = "I know a lot of Magic, child. More than you'll ever know.";
                    break;
                
            }
            
            return text;
            
        }

        public override void SetupShop(Chest chest, ref int index) {
            
            // The cost to buy this item is the value that was in the items JSON file
            chest.item[index].SetDefaults(ItemDef.byName["Vanilla:Top Hat"].type);
            index++;
            
            chest.item[index].SetDefaults(ItemDef.byName["Vanilla:Feather"].type);
            index++;
            
            chest.item[index].SetDefaults(ItemDef.byName["Vanilla:Cobweb"].type);
            index++;
            
            chest.item[index].SetDefaults(ItemDef.byName["Vanilla:Iron Chain"].type);
            index++;

            chest.item[index].SetDefaults(ItemDef.byName["Terra:Popcorn"].type);
            index++;
            
        }
        
        public override bool ResetShop(Chest chest) { return true; }

        public override void SetChatButtons(ref string[] buttons) {//you can have up to 5 buttons (0-4)
			buttons[0] = "Shop";
		}
        
		public override void OnChatButtonClicked(string[] buttons, int buttonIndex, ref bool openShop) {
            
			if (buttonIndex == 0) {
				openShop = true;
			}
            
		}
        
    }
    
}